irq_4:
	sta $04
	stx $03
	sty $02
	lda #$05
	sta $01
	lda #$03
	sta $d011
	
keycheck:
	lda #%11111110
	sta $dc00
	lda $dc01
	eor #%11111111
	tay
	and #%00000010
	sta go_fire+1
	lda #%10111111
	sta $dc00
	lda $dc01
	eor #%11101111
	beq !+
	lda #%11111101
	sta $dc00
	lda $dc01
	eor #%01111111
	beq !+
	lda #$00
	sta go_left+1
	sta go_up+1
	tya
	and #%10000000
	sta go_down+1
	tya
	anc #%00000100
	sta go_right+1	
	bcc keycheck_done
!:	sta go_right+1
	sta go_down+1
	tya
	and #%10000000
	sta go_up+1
	tya
	and #%00000100
	sta go_left+1
keycheck_done:
	lda #%11111111
	sta $dc00
	lda $dc00
	eor #%11111111
	and #$10
	ora go_fire+1
	sta go_fire+1
	lda $dc00
	eor #%11111111
	and #$08
	ora go_right+1
	sta go_right+1
	lda $dc00
	eor #%11111111
	and #$04
	ora go_left+1
	sta go_left+1
	lda $dc00
	eor #%11111111
	and #$02
	ora go_down+1
	sta go_down+1
	lda $dc00
	eor #%11111111
	and #$01
	ora go_up+1
	sta go_up+1
	
	lda #$01
	sta $d019
	lda #<irq_1
	sta $fffe
	lda #>irq_1
	sta $ffff
	lda #$00
	sta $d012	
	ldy $02
	ldx $03
	lda #$00
	sta $01
	lda $04
	rti