.pc=$0800 "DUALUX LOGO"
	.import binary "dualux"

.import source "decruncher.asm"
.pc=* "Scroll speed lookup table"
scroll_speed_table:
	.byte 0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,6,6,6,6,7,7,7,7,8,8,8

.pc=* "Flash table"
flasher:
	.fill 57,8
	.byte $06 | 8
	.byte $04 | 8
	.byte $03 | 8
	.byte $07 | 8
	.byte $01 | 8
	.byte $07 | 8
	.byte $03 | 8
	.byte $04 | 8
	.byte $06 | 8

flasher_s:
	.fill 57,0
	.byte $06
	.byte $04
	.byte $03
	.byte $07
	.byte $01
	.byte $07
	.byte $03
	.byte $04
	.byte $06

.pc=* "Volume table"
volume_table:
	.byte $ff,$fe,$fe,$fd,$fd,$fd,$fc,$fc,$fc,$fb,$fb,$fb,$fa,$fa,$fa
	.byte $f9,$f9,$f9,$f8,$f8,$f8,$f7,$f7,$f7,$f6,$f6,$f6,$f5,$f5,$f5,$f4,$f4,$f4,$f3,$f3,$f3,$f2,$f2,$f2,$f1,$f1,$f1,$f0,$f0

sine_x_table:
	.byte $18,$18,$18,$19,$19,$1a,$1a,$1b
	.byte $1c,$1d,$1d,$1e,$1e,$1f,$1f,$1f
	.byte $1f,$1f,$1f,$1e,$1e,$1d,$1d,$1c
	.byte $1b,$1a,$1a,$19,$19,$18,$18,$18

fade_table:
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$09,$09,$06,$06,$0b,$0b,$02,$02,$08,$08,$04,$04,$0e,$0e
	.byte $0c,$0c,$0a,$0a,$05,$05,$0f,$0f,$03,$03,$0d,$0d,$07,$07,$01,$01
	.byte $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
	.byte $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01

.pc=$0bf8 "Sprite pointers TOP"
	.byte $d5,$d6,$d7,$d8,$d9,$da,$db,$dc
.import source "fontcode.asm"
.pc=$0fff "Music"
	.byte $00,$60,$60,$60,$60
	
.pc=* "SETUP CODE 1"
.import source "writelines.asm"


.pc=$1200 "STARTUP"
	.import source "startupcode.asm"
	
.pc=$3540 "Sprites"
.import binary "sprites2"
.pc=$3740 "Arrows"
.import binary "arrows"
.pc=$3800 "Font gfx"
.import binary "font2.gfx"

.pc=$4000 "Sine table"
sine_x:
	.import binary "sine1"

.pc=* "IRQ1"
.import source "irq1.asm"

.pc=* "IRQ2"
.import source "irq2.asm"

.pc=* "IRQ4"
.import source "irq4.asm"

.pc=* "Digit data"
.import source "digits.asm"

.pc=* "Music storage lookup"
music_load_start:
	.word music_stereoof11_start
	.word music_lonelysample_start
	.word music_megapowerman_start
	.word music_adventure_start
	.word music_roy_start
	.word music_hooker_start
	.word music_experiment5_start
	.word music_spacejourney_start
	.word music_huelsbeck_start
	.word music_fastlane_start
	.word music_blankpage_start
	.word music_shittyfunk_start
	.word music_loveandpain_start
music_load_end:
	.word music_stereoof11_end
	.word music_lonelysample_end
	.word music_megapowerman_end
	.word music_adventure_end
	.word music_roy_end
	.word music_hooker_end
	.word music_experiment5_end
	.word music_spacejourney_end
	.word music_huelsbeck_end
	.word music_fastlane_end
	.word music_blankpage_end
	.word music_shittyfunk_end
	.word music_loveandpain_end

.pc=$7850 "CRUNCHED MUSIC STORAGE"
music_adventure_start:
	.import binary "complete/adventure"
music_adventure_end:
music_roy_start:
	.import binary "complete/roygbiv"
music_roy_end:
music_hooker_start:
	.import binary "complete/hooker"
music_hooker_end:
music_lonelysample_start:
	.import binary "complete/lonelysample"
music_lonelysample_end:
music_stereoof11_start:
	.import binary "complete/stereoof11"
music_stereoof11_end:
music_spacejourney_start:
	.import binary "complete/spacejourney"
music_spacejourney_end:
music_experiment5_start:
	.import binary "complete/experiment5"
music_experiment5_end:
music_huelsbeck_start:
	.import binary "complete/huelsbeck"
music_huelsbeck_end:
music_fastlane_start:
	.import binary "complete/fastlane"
music_fastlane_end:
music_megapowerman_start:
	.import binary "complete/megapowerman"
music_megapowerman_end:
music_loveandpain_start:
	.import binary "complete/loveandpain"
music_loveandpain_end:
music_blankpage_start:
	.import binary "complete/blankpage"
music_blankpage_end:
music_shittyfunk_start:
	.import binary "complete/shittyfunk"
music_shittyfunk_end:



.pc=* "MAIN SCROLLTEXT"
scroll_text_startup:
	.text "                                                                        "
	.text "... pozdrowienia, stary piernik!          "
scroll_text:
	.byte $80
	.text "connect your dick into port 2 and start fucking around with the scroll speed as well as selecting the tunes available in the list above.     "
	.byte $80
	.text "if you do not have a joystick, then you can bash the cursor keys and the return key.         "
	.byte $80
	.text "so...  what is the crack of this then?   "
	.text "well, it is a collection of complete and unfinished 2sids composed by conrad of samar!      yes, "
	.byte $80
	.text "i thought i would bundle all of these tunes together into one pack and release it as a nice music collection, with style!            "
	.byte $80
	.text "all coding, graphics and tunes by conrad!         "
	.byte $80
	.text "first released at stary piernik, the seventh edition!          "
	.byte $80
	.text "hello to everyone at stary piernik!   i hope you all enjoy this nice little collection of mine!        "
	.byte $80
	.text "these are tunes that i just seriously need to rid off and start a fresh!        "
	.byte $80
	.text "rather than dump them straight to hvsc,  why not release them with style?  eh?        "
	.byte $80
	.text "enjoy the rest of the evening!        "
	.byte $80
	.text "personal hellos to... all my groupmates in samar, viruz, and onslaught,  everyone of irc channels and csdb,   people i have met at parties,  "
	.text "and everyone else i know in the commodore scene!...  its become very hard to remember every name, but you know exactly who you are!    "
	.byte $80
	.text "no fuckings, because i am a nice guy!   heheheh!     "
	.byte $80
	.text "by the way,  some of you may have heard a few of these tunes before, as i used to have these on soundcloud at one point.    but now they are "
	.text "finally here, playing on your sixty four machine,  so that you can get the best experience out of it!       "
	.byte $80
	.text "well, i have not really much to say now, so its time for me to wrap this crap!    "
	.text "cheerio dudes and dudettes!   "
	.byte $80
	.text "happy listening!                               "
	.byte $00
	
back2mainscrolltext:
	.text " ... ... "
	.byte $00