	sei
	cld
	lda #$07
	sta $00
	lda #$05
	sta $01
	lda #<nmi
	sta $fffa
	lda #>nmi
	sta $fffb
	lda #$00
	sta $d015
	lda #$03
	sta $dd00
	lda #$1b
	sta $d011
	lda #$08
	sta $d016
	lda #$0f
	sta $02
startup_loop1:
!:	bit $d011
	bpl !-
!:	bit $d011
	bmi !-
	lda $d020
	and #$0f
	tay
	lda fade_to_white,y
	sta $d020
	lda $d021
	and #$0f
	tay
	lda fade_to_white,y
	sta $d021
	ldx #$00
!:	lda $d800,x
	and #$0f
	tay
	lda fade_to_white,y
	sta $d800,x
	lda $d900,x
	and #$0f
	tay
	lda fade_to_white,y
	sta $d900,x
	lda $da00,x
	and #$0f
	tay
	lda fade_to_white,y
	sta $da00,x
	lda $db00,x
	and #$0f
	tay
	lda fade_to_white,y
	sta $db00,x
	dex
	bne !-
	dec $02
	bpl startup_loop1
	lda #$00
	sta $d011
	sta $d022
	sta $d023
	sta $d025
	sta $d026
	sta $d027
	sta $d028
	sta $d029
	sta $d02a
	sta $d02b
	sta $d02c
	sta $d02d
	sta $d02e
	lda #$86
	sta $d018
	ldx #$00
!:	lda #$08
	sta $d800,x
	sta $d900,x
	sta $da00,x
	sta $db00,x
	lda #$ff
	sta $0200,x
	lda #$00
	sta $0240,x
	sta $0340,x
	sta $0440,x
	sta $0540,x
	sta $0640,x
	sta $0700,x
	dex
	bne !-
	ldy #$08
	sty $03f8
	sty $03f9
	iny
	sty $03fa
	sty $03fd
	iny
	sty $03fb
	sty $03fe
	iny
	sty $03fc
	sty $03ff
	lda #%00011100
	sta $02c0+[3*2]
	sta $02c0+[3*3]
	sta $02c0+[3*8]
	sta $02c0+[3*9]
	jsr convert_lines
	ldx #$06
	lda #$08
!:	sta $07f8,x
	dex
	bpl !-
	stx $d015
	ldx #$10
!:	lda #$00
	sta $d000,x
	dex
	bpl !-
	lda #<irq_1
	sta $fffe
	lda #>irq_1
	sta $ffff
	lda #$00
	sta $dc0f	
	lda #$91
	sta $dc0e
	lda #$7f
	sta $dc0d
	lda $dc0d
	lda #$01
	sta $d01a
	sta $d019
	lda #$00
	sta $d012
select_fade_loop:
!:	bit $d011
	bpl !-
!:	bit $d011
	bmi !-
	lda #$1f
	sta $d011
select_fade_index:
	ldx #$40
	clc
	txa
	adc #$1e
	tay
	lda fade_table,y
	ldy #$17
!:	sta $d8f8,y
	sta $d970,y
	sta $d9c0,y
	sta $da10,y
	sta $dab0,y
	dey
	bpl !-
	txa
	adc #$0e
	tay
	lda fade_table,y
	sta select_fade_1+1
	txa
	adc #$0c
	tay
	lda fade_table,y
	sta select_fade_2+1
	lda #$52
!:	cmp $d012
	bne !-
	lda #$01
	sta $d020
	sta $d021
	ldx #$08
!:	dex
	bpl !-
select_fade_1:
	lda #$00
	sta $d020
	sta $d021
	lda #$d5
!:	cmp $d012
	bne !-
	ldx #$0a
!:	dex
	bpl !-
	lda #$01
	sta $d020
	sta $d021
	ldx #$08
!:	dex
	bpl !-
select_fade_2:
	lda #$00
	sta $d020
	sta $d021	
	lda select_fade_index+1
	bne !+
	lda #$18
	sta $d016
	lda #$1e
	sta $d018
	ldy #$17
	lda #$08
clear_shit:
	sta $d8f8,y
	sta $d970,y
	sta $d9c0,y
	sta $da10,y
	sta $dab0,y
	dey
	bpl clear_shit
	cli
	iny
	sty $01
	jmp load_tune
!:	eor #$20
	beq select_2sid
	dec select_fade_index+1
	jmp select_fade_loop
select_2sid:
	ldy #$d4
	ldx #$20
	lda #$7f
	sta $dc00
	lda $dc01
	cmp #$fe
	bne !+
	jmp set_2sid
!:	ldy #$d5
	ldx #$00
	cmp #%11110111
	bne !+
	jmp set_2sid
!:	ldy #$de
	ldx #$00
	lda #$fd
	sta $dc00
	lda $dc01
	cmp #$fe
	bne !+
set_2sid:
	lda #$00
	sta $06
	dec select_fade_index+1
	jsr write_registers
!:	jmp select_fade_loop



write_registers:
	//; voice 1
	stx $4167
	sty $4168
	stx $5dcd
	sty $5dce
	inx
	stx $416d
	sty $416e
	stx $5dd3
	sty $5dd4
	inx
	stx $414f
	sty $4150
	stx $5db5
	sty $5db6
	inx
	stx $4155
	sty $4156
	stx $5dbb
	sty $5dbc
	inx
	stx $4173
	sty $4174
	stx $5dd9
	sty $5dda
	inx
	stx $4161
	sty $4162
	stx $5dc7
	sty $5dc8	
	inx
	stx $415b
	sty $415c
	stx $5dc1
	sty $5dc2
	inx	

	//; voice 2
	stx $41bb
	sty $41bc
	stx $5e41
	sty $5e42
	inx
	stx $41c1
	sty $41c2
	stx $5e47
	sty $5e48
	inx
	stx $41a3
	sty $41a4
	stx $5e29
	sty $5e2a
	inx
	stx $41a9
	sty $41aa
	stx $5e2f
	sty $5e30
	inx
	stx $41c7
	sty $41c8
	stx $5e4d
	sty $5e4e
	inx
	stx $41b5
	sty $41b6
	stx $5e3b
	sty $5e3c	
	inx
	stx $41af
	sty $41b0
	stx $5e35
	sty $5e36
	inx

	//; voice 3
	stx $420f
	sty $4210
	stx $5e95
	sty $5e96
	inx
	stx $4215
	sty $4216
	stx $5e9b
	sty $5e9c
	inx
	stx $41f7
	sty $41f8
	stx $5e7d
	sty $5e7e
	inx
	stx $41fd
	sty $41fe
	stx $5e83
	sty $5e84
	inx
	stx $421b
	sty $421c
	stx $5ea1
	sty $5ea2
	inx
	stx $4209
	sty $420a
	stx $5e8f
	sty $5e90	
	inx
	stx $4203
	sty $4204
	stx $5e89
	sty $5e8a
	inx	
	
	//;filter
	stx $4227
	sty $4228
	stx $5de8
	sty $5de9	
	inx	
	stx $4233
	sty $4234
	stx $5ead
	sty $5eae	
	inx	
	stx $423f
	sty $4240
	stx $5eb9
	sty $5eba	
	inx	
	stx $424b
	sty $424c
	stx $5ec5
	sty $5ec6	
	rts

fade_to_white:
	.byte $09,$01,$08,$0d,$0e,$0f,$0b,$01
	.byte $04,$06,$05,$02,$0a,$07,$0c,$03
	
.pc=$2000 
	.fill $400,$20
.pc=$20f8
	.text "Please set 2SID address:"
.pc=$2178
	.text "1> $D420"
.pc=$21c8
	.text "2> $D500"
.pc=$2218
	.text "3> $DE00"
.pc=$22b2
	.text "(C)2012 CONRAD/SAMAR"
	
.pc=$3200 "OUTSIDE ROUTINE"
load_tune_safe:
	lda scroll_text_lookup+2
	bmi load_tune
	lda #<back2mainscrolltext
	sta scroll_text_lookup+1
	lda #>back2mainscrolltext
	sta scroll_text_lookup+2
load_tune:
	lda #$02
	asl
	tax
	lda music_load_start,x
	sta load_tune_srce+1
	lda music_load_end,x
	sta load_tune_endlo+1
	inx
	lda music_load_start,x
	sta load_tune_srce+2
	lda music_load_end,x
	sta load_tune_endhi+1	
	lda #$fd
	sta load_tune_dest+1
	lda #$0f
	sta load_tune_dest+2
load_tune_srce:
	lda $ffff
load_tune_dest:
	sta $ffff
	inc load_tune_dest+1
	bne !+
	inc load_tune_dest+2
!:	inc load_tune_srce+1
	bne !+
	inc load_tune_srce+2
!:	lda load_tune_srce+1
load_tune_endlo:
	cmp #$00
	bne load_tune_srce
	lda load_tune_srce+2
load_tune_endhi:
	cmp #$00
	bne load_tune_srce
	sta opbase+2
	lda load_tune_srce+1
	sta opbase+1
	cld
	jsr exod_decrunch
	ldy $0fff
	beq !+
asjdoajsodjsad:
	lda flasher_i1+1
	ora flasher_i2+1
	ora flasher_i3+1
	ora flasher_i4+1
	cmp #$20
	bcs asjdoajsodjsad
!:	sty f_2+1
the_very_first_time:
	lda #$00
	bne !+
	inc the_very_first_time+1
	bne the_very_first_time_
scroll_restart_point1:
!:	lda #$00
	sta scroll_restart_+1
scroll_restart_point2:
	lda #$00
	sta scroll_restart+1
	lda $0ffd
	sta scroll_text_lookup+1
	lda $0ffe
	sta scroll_text_lookup+2
the_very_first_time_:
	lda #$00
	ldx #$38
!:	sta $c0,x
	dex
	bne !-
	sta vol_down+1
outside_loop:
	lda vol_down+1
	eor #$2b
	bne play_it
	jmp load_tune_safe
play_it:
	lda #$00
	bne !+
	jmp play_it_
!:  jsr $1003
	.for (var i=0;i<$18;i=i+1)
	{
		lda $c0+i
		sta $0bb0+i
		lda $e0+i
		sta $0bd0+i
	}
	ldx vol_down+1
	lda $d8
	and volume_table,x
	sta $0bc8
	lda $f8
	and volume_table,x
	sta $0be8
play_it_twice:
	lda $0fff
	bne !+
	jmp play_it___
!:	jsr $1003
	.for (var i=0;i<$18;i=i+1)
	{
		lda $c0+i
		sta $37c0+i
		lda $e0+i
		sta $37e0+i
	}
	jmp play_it__
play_it___:
	ldx #$37
!:	lda $c0,x
	sta $37c0,x
	dex
	bpl !-
play_it__:
	ldx vol_down+1
	lda $d8
	and volume_table,x
	sta $37d8
	lda $f8
	and volume_table,x
	sta $37f8
	lda #$00
	sta play_it+1	
play_it_:
	jmp outside_loop