irq_1:
	sta $04
	stx $03
	sty $02
	lda #$05
	sta $01
	lda #$18
	sta $d011
colour_outside_3:
	lda #$00
colour_outside_4:
	ldx #$00
colour_outside_5:
	ldy #$00
	sta $d021
	stx $d023
	sty $d022
	sty $d020

dsid_base1:
	.for (var x=0; x<3; x=x+1)
	{
		lda $0bb2+[x*7]
		sta $d402+[x*7]
		lda $0bb3+[x*7]
		sta $d403+[x*7]
		lda $0bb6+[x*7]
		sta $d406+[x*7]
		lda $0bb5+[x*7]
		sta $d405+[x*7]
		lda $0bb0+[x*7]
		sta $d400+[x*7]
		lda $0bb1+[x*7]
		sta $d401+[x*7]
		lda $0bb4+[x*7]
		sta $d404+[x*7]
		lda $0bd2+[x*7]
		sta $d422+[x*7]
		lda $0bd3+[x*7]
		sta $d423+[x*7]
		lda $0bd6+[x*7]
		sta $d426+[x*7]
		lda $0bd5+[x*7]
		sta $d425+[x*7]
		lda $0bd0+[x*7]
		sta $d420+[x*7]
		lda $0bd1+[x*7]
		sta $d421+[x*7]
		lda $0bd4+[x*7]
		sta $d424+[x*7]
	}
	lda $0bc5
	sta $d415
	lda $0be5
	sta $d435
	lda $0bc6
	sta $d416
	lda $0be6
	sta $d436
	lda $0bc7
	sta $d417	
	lda $0be7
	sta $d437
	lda $0bc8
	sta $d418
	lda $0be8
	sta $d438	

logo_sinex:
	lda #$18
	sta $d016
	lda #$2e
	sta $d018
colour_outside_6:
	lda #$00
	sta $d025
colour_outside_7:
	lda #$00
	sta $d026
	lda #$14
	sta $d001
	sta $d003
	sta $d005
	sta $d007
	clc
	adc #21
	sta $d009
	sta $d00b
	sta $d00d
	sta $d00f
sprite_sinex:
	lda #$30
	sta $d000
	sta $d008
	adc #$18
	sta $d002
	sta $d00a
	adc #$18
	sta $d004
	sta $d00c
	adc #$18
	sta $d006
	sta $d00e
fl_1:	
	lda #$00
	sta $d027
	sta $d02b
fl_2:
	lda #$00
	sta $d028
	sta $d02c
fl_3:
	lda #$00
	sta $d029
	sta $d02d
fl_4:
	lda #$00
	sta $d02a
	sta $d02e
	ldy #$00
	sty $d017
	sty $d010
	dey 
	sty $d01c
scroll_speed_index:	
	ldy #$13
go_left:
	lda #$00
	beq go_right
	iny 
	cpy #$20
	bne !+
	ldy #$1f
	bne !+
go_right:
	lda #$00
	beq !+
	dey
	bpl !+
	ldy #$00
!:	sty scroll_speed_index+1
	lda bottom_scroll_d016+1
	sec
scroll_speed:
	sbc scroll_speed_table,y
	bcc !+
	sta bottom_scroll_d016+1
	jmp scroll_
!:	adc #$08
	sta bottom_scroll_d016+1
	.for (var x=0; x<$26; x=x+1)
	{
		lda $0321+x
		sta $0320+x
		lda $0349+x
		sta $0348+x
		lda $0371+x
		sta $0370+x
		lda $0399+x
		sta $0398+x
	}
scroll_charpos:
	ldy #$00
scroll_lookup_1:
	lda $ff00,y
	sta $0346
scroll_lookup_2:
	lda $ff00,y
	sta $036e
scroll_lookup_3:
	lda $ff00,y
	sta $0396
scroll_lookup_4:
	lda $ff00,y
	sta $03be
	iny
scroll_lookup_5:
	cpy #$01
	beq scroll_text_lookup
	jmp scroll__
	
scroll_restart2:
	lda scroll_text_lookup+1
	clc
	adc #$01
	sta scroll_restart_point1+1
	sta scroll_text_lookup+1
	lda scroll_text_lookup+2
	adc #$00
	sta scroll_restart_point2+1
	sta scroll_text_lookup+2
	bcc scroll_text_lookup
scroll_restart:
	lda #>scroll_text
	sta scroll_text_lookup+2
scroll_restart_:
	lda #<scroll_text
	sta scroll_text_lookup+1
	lda #>scroll_text
	sta scroll_restart+1		
	lda #<scroll_text
	sta scroll_restart_+1
scroll_text_lookup:
	ldx scroll_text_startup
	bmi scroll_restart2
	beq scroll_restart
	inc scroll_text_lookup+1
	bne !+
	inc scroll_text_lookup+2
!:	lda font_lookup_length,x
	sta scroll_lookup_5+1
	lda font_lookup_tablehi,x
	sta scroll_lookup_1+2
	lda font_lookup_tablelo,x
	sta scroll_lookup_1+1
	clc
	adc #$28
	sta scroll_lookup_2+1
	lda scroll_lookup_1+2
	adc #$0
	sta scroll_lookup_2+2	
	lda scroll_lookup_2+1
	adc #$28
	sta scroll_lookup_3+1
	lda scroll_lookup_2+2
	adc #$0
	sta scroll_lookup_3+2	
	lda scroll_lookup_3+1
	adc #$28
	sta scroll_lookup_4+1
	lda scroll_lookup_3+2
	adc #$0
	sta scroll_lookup_4+2	
	ldy #$00
scroll__:
	sty scroll_charpos+1
scroll_:
	lda vol_down+1
	eor #$2b
	bne !+
	lda #[$3780/$40]
	sta $03fd
	sta $03fa
	lda #$00
	sta $dc08
	sta $dc09
	sta $dc0a
	lda #$07
	jmp ajajajaja
!:	lda #[$3740/$40]
	sta $03fd
	sta $03fa
	lda #$0d
ajajajaja:
	sta sprite_colour+1
	lda $dc09
	and #$0f
	tax
	ldy digit_lookup,x
	.for (var y=0;y<$c;y=y+1)
	{
		lda digit_data+y,y
		sta $02c2+[y*3]
	}
	lda $dc09
	lsr
	lsr
	lsr
	lsr
	tax
	ldy digit_lookup,x
	.for (var y=0;y<$c;y=y+1)
	{
		lda digit_data+y,y
		sta $02c1+[y*3]
	}
	lda $dc0a
	and #$0f
	tax
	ldy digit_lookup,x
	.for (var y=0;y<$c;y=y+1)
	{
		lda digit_data+y,y
		sta $0282+[y*3]
	}

	
	clc	
f_2:
	lda #$00
	beq fadein_inside
f_0:
	ldx #$00
	inx
	stx f_0+1
	bne f_1
	lda outside_fader+1
	adc #$40
	sta outside_fader+1
f_1:jmp outside_fade_index

fadein_inside:
	ldx #$00
	cpx #$21
	beq fadein_player_
fadein_player:
	ldx #$00
	cpx #$21
	beq !+
	txa
	adc #$0c
	tay
	lda fade_table,y
	sta sprite_colour+1
	txa
	adc #$1e
	tay
	lda fade_table,y
	sta sprite_colour2+1
	inx
	stx fadein_player+1
	jmp fadein_player_
!:	ldx fadein_inside+1
	lda vol_down+1
	bne fadein_player_
	txa
	adc #$06
	tay
	lda fade_table,y
	sta colour_inside_0+1
	sta colour_inside_7+1
	txa
	adc #$10
	tay
	lda fade_table,y
	sta colour_inside_1+1
	sta colour_inside_2+1
	sta colour_inside_9+1
	txa
	adc #$16
	tay
	lda fade_table,y
	sta colour_inside_3+1
	sta colour_inside_8+1
	txa
	adc #$18
	tay
	lda fade_table,y
	sta colour_inside_4+1
	txa
	adc #$14
	tay
	lda fade_table,y
	sta colour_inside_5+1
	txa
	adc #$1a
	tay
	lda fade_table,y
	sta colour_inside_6+1	
	inx
	stx fadein_inside+1
fadein_player_:

flasher_i1:
	ldx #$00
	bne !+
	jmp flasher_i2
!:	.for (var i=$24;i>=0;i=i-3)
	{
		lda $d800+i+[$28*$a]
		sta $d801+i+[$28*$a]
		sta $d802+i+[$28*$a]
		sta $d803+i+[$28*$a]
		sta $d801+i+[$28*$b]
		sta $d802+i+[$28*$b]
		sta $d803+i+[$28*$b]
		sta $d801+i+[$28*$c]
		sta $d802+i+[$28*$c]
		sta $d803+i+[$28*$c]
		sta $d801+i+[$28*$d]
		sta $d802+i+[$28*$d]
		sta $d803+i+[$28*$d]
	}
	lda flasher,x
	sta $d800+[$28*$a]
	sta $d800+[$28*$b]
	sta $d800+[$28*$c]
	sta $d800+[$28*$d]
	dex
	stx flasher_i1+1
	bne !+
	lda #$3f
	sta flasher_i2+1
!:	jmp flasher_end
flasher_i2:
	ldx #$00
	bne !+
	jmp flasher_i3
!:  .for (var i=$0;i<$1e;i=i+3)
	{
		lda $d803+i+[$28*$0]
		sta $d802+i+[$28*$0]
		sta $d801+i+[$28*$0]
		sta $d800+i+[$28*$0]
		sta $d802+i+[$28*$1]
		sta $d801+i+[$28*$1]
		sta $d800+i+[$28*$1]
		sta $d802+i+[$28*$2]
		sta $d801+i+[$28*$2]
		sta $d800+i+[$28*$2]
		sta $d802+i+[$28*$3]
		sta $d801+i+[$28*$3]
		sta $d800+i+[$28*$3]
	}
	lda flasher,x
	sta $d81e+[$28*$0]
	sta $d81e+[$28*$1]
	sta $d81e+[$28*$2]
	sta $d81e+[$28*$3]
	dex
	stx flasher_i2+1
	bne !+
	lda #$3f
	sta flasher_i3+1
!:	jmp flasher_end
flasher_i3:
	ldx #$00
	bne !+
	jmp flasher_i4
!:	lda fl_3+1
	sta fl_4+1
	lda fl_2+1
	sta fl_3+1
	lda fl_1+1
	sta fl_2+1
	lda flasher_s,x
	sta fl_1+1
	dex
	stx flasher_i3+1
	bne !+
	lda #$3f
	sta flasher_i4+1
!:	jmp flasher_end
flasher_i4:
	ldx #$00
	bne !+
	jmp flasher_fake
!:	.for (var i=$0;i<=$24;i=i+3)
	{
		lda $d803+i+[$28*$14]
		sta $d802+i+[$28*$14]
		sta $d801+i+[$28*$14]
		sta $d800+i+[$28*$14]
		sta $d802+i+[$28*$15]
		sta $d801+i+[$28*$15]
		sta $d800+i+[$28*$15]
		sta $d802+i+[$28*$16]
		sta $d801+i+[$28*$16]
		sta $d800+i+[$28*$16]
		sta $d802+i+[$28*$17]
		sta $d801+i+[$28*$17]
		sta $d800+i+[$28*$17]
	}
	lda flasher,x
	sta $d827+[$28*$14]
	sta $d827+[$28*$15]
	sta $d827+[$28*$16]
	sta $d827+[$28*$17]
	dex
	stx flasher_i4+1
	bne !+
	lda #$3f
	sta flasher_fake+1
!:	jmp flasher_end
flasher_fake:
	ldx #$cf
	dex
	stx flasher_fake+1
	bne flasher_end
	lda #$3f
	sta flasher_i1+1
	lda outside_fader+1
	adc #$40
	sta outside_fader+1
flasher_end:









outside_fade_index:
	ldx #$00
outside_fader:
	lda #$40
	bmi !+
	jmp outside_fader_
!:	clc
	txa
outside_fader_1:
	adc #$04
	tay
	lda fade_table,y
	sta colour_outside_0+1
	sta $06
	txa
outside_fader_2:
	adc #$06
	tay
	lda fade_table,y
	sta colour_outside_1+1
	txa
outside_fader_3:
	adc #$0e
	tay
	lda fade_table,y
	sta colour_outside_2+1
	txa
outside_fader_4:
	adc #$0a
	tay
	lda fade_table,y
	sta colour_outside_4+1
	sta colour_outside_7+1
	txa
outside_fader_5:
	adc #$12
	tay
	lda fade_table,y
	sta colour_outside_3+1
	txa
outside_fader_6:
	adc #$08
	tay
	lda fade_table,y
	sta colour_outside_5+1
	txa
outside_fader_7:
	adc #$02
	tay
	lda fade_table,y
	sta colour_outside_6+1

outside_fader_state:
	lda #$00
	bne outside_fader_out

	inx
	stx outside_fade_index+1
	cpx #$21
	bne !+
	lda #$00
	sta outside_fader+1
	inc outside_fader_state+1
!:	jmp outside_fader_
	
outside_fader_out:
	dex
	stx outside_fade_index+1
	bne outside_fader_
	dec outside_fader_state+1
	ldx outside_fader_1+1
	lda outside_fader_6+1
	sta outside_fader_1+1
	stx outside_fader_6+1
	ldx outside_fader_2+1
	lda outside_fader_4+1
	sta outside_fader_2+1
	stx outside_fader_4+1
	ldx outside_fader_3+1
	lda outside_fader_5+1
	sta outside_fader_3+1
	stx outside_fader_5+1
	lda outside_fader_7+1
	eor #$0e
	sta outside_fader_7+1
outside_fader_:





	


	

	lda #$01
	sta $d019
	lda #<irq_2
	sta $fffe
	lda #>irq_2
	sta $ffff
	lda #$51
	sta $d012
	ldy $02
	ldx $03
	lda #$00
	sta $01
	lda $04
nmi:
	rti