.var screen_b = $05
irq_2:
	sta $04
	stx $03
	sty $02
	
	lda #$05
	sta $01
	
	lda #$01
colour_inside_0:
	ldx #$00
colour_inside_1:
	ldy #$00
	stx $d022
	sty $d023
scroll_0:
	ldx #$00
	stx $d016
	//ldx #$04
	ldx #$03
!:	dex
	bne !-
	clc
	sta $d020
	sta $d021
colour_inside_2:
	ldy #$00//$0c
colour_inside_3:
	lda #$00//$0f
	ldx #$09
!:	dex
	bne !-
	
scroll_1:
	ldx #$18
	
	sta $d021
	sty $d020
	ldy #$1e
	sty $d018
	ldy #$1f
	sty $d011
	sta $d026
	lda #86
	sta $d001
	sta $d003
	lda #128
	sta $d005
	sta $d007
	lda #170
	sta $d009
	sta $d00b
	lda #8
	sta $d000
	sta $d004
	sta $d008
	lda #80
	sta $d002
	sta $d006
	sta $d00a
	lda #%00111111
	sta $d017
	lda #%00101010
	sta $d010

screen_1:	
	ldy #$28
	.for (var x=$26; x>$0; x=x-1)
	{
		lda ($42),y
		sta $04a0+x+[$28*1]
		iny
	}	
	lda ($42),y
	sta $04a0+[$28*1]
	
screen_2:
	ldy #$28
	.for (var x=$26; x>$1a; x=x-1)
	{
		lda ($44),y
		sta $04a0+x+[$28*2]
		iny
	}	
	
	stx $d016
scroll_2:	
	ldx #$19

	.for (var x=$1a; x>$0; x=x-1)
	{
		lda ($44),y
		sta $04a0+x+[$28*2]
		iny
	}
	lda ($44),y
	sta $04a0+[$28*2]

screen_3:
	ldy #$28
	.for (var x=$26; x>$1d; x=x-1)
	{
		lda ($46),y
		sta $04a0+x+[$28*3]
		iny
	}	
	
	stx $d016
scroll_3:
	ldx #$1a
	.for (var x=$1d; x>$0; x=x-1)
	{
		lda ($46),y
		sta $04a0+x+[$28*3]
		iny
	}
	lda ($46),y
	sta $04a0+[$28*3]

screen_4:
	ldy #$28
	.for (var x=$26; x>$1f; x=x-1)
	{
		lda ($48),y
		sta $04a0+x+[$28*4]
		iny
	}	
	
	stx $d016

scroll_4:
	ldx #$1b
	.for (var x=$1f; x>$0; x=x-1)
	{
		lda ($48),y
		sta $04a0+x+[$28*4]
		iny
	}
	lda ($48),y
	sta $04a0+[$28*4]

screen_5:
	ldy #$28
	.for (var x=$26; x>$22; x=x-1)
	{
		lda ($4a),y
		sta $04a0+x+[$28*5]
		iny
	}	
	stx $d016

scroll_5:
	ldx #$1c
	.for (var x=$22; x>$0; x=x-1)
	{
		lda ($4a),y
		sta $04a0+x+[$28*5]
		iny
	}
	lda ($4a),y
	sta $04a0+[$28*5]
	
screen_7:
	ldy #$28
	.for (var x=$26; x>$25; x=x-1)
	{
		lda ($4e),y
		sta $04a0+x+[$28*7]
		iny
	}	
	
	stx $d016
	
	.for (var x=$25; x>$11; x=x-1)
	{
		lda ($4e),y
		sta $04a0+x+[$28*7]
		iny
	}	

colour_inside_4:
	lda #$00
colour_inside_5:
	ldx #$00
	sta $d023
colour_inside_6:
	lda #$00
	stx $d022
	sta $d026
	sta $d020
	sta $d021
	
scroll_6:
	ldx #$1e

	.for (var x=$11; x>$03; x=x-1)
	{
		lda ($4e),y
		sta $04a0+x+[$28*7]
		iny
	}
	lda ($4e),y

	stx $d016
scroll_7:
	ldx #$1f

	sta $04a3+[$28*7]
	iny
	lda ($4e),y
	sta $04a2+[$28*7]
	iny
	lda ($4e),y
	sta $04a1+[$28*7]
	iny
	lda ($4e),y
	sta $04a0+[$28*7]


screen_8:
	ldy #$28
	.for (var x=$26; x>$05; x=x-1)
	{
		lda ($50),y
		sta $04a0+x+[$28*8]
		iny
	}
	
	stx $d016

scroll_8:
	ldx #$18
	
	.for (var x=$05; x>$0; x=x-1)
	{
		lda ($50),y
		sta $04a0+x+[$28*8]
		iny
	}
	lda ($50),y
	sta $04a0+[$28*8]

screen_9:
	ldy #$28
	.for (var x=$26; x>$08; x=x-1)
	{
		lda ($52),y
		sta $04a0+x+[$28*9]
		iny
	}
	
	stx $d016
	
scroll_9:	
	ldx #$19

	.for (var x=$08; x>$0; x=x-1)
	{
		lda ($52),y
		sta $04a0+x+[$28*9]
		iny
	}
	lda ($52),y
	sta $04a0+[$28*9]
	

screen_a:
	ldy #$28
	.for (var x=$26; x>$0b; x=x-1)
	{
		lda ($54),y
		sta $04a0+x+[$28*$a]
		iny
	}
	lda ($54),y
	stx $d016
scroll_a:
	ldx #$1a
	sta $04a0+$b+[$28*$a]
	iny
	.for (var x=$0a; x>$0; x=x-1)
	{
		lda ($54),y
		sta $04a0+x+[$28*$a]
		iny		
	}
	lda ($54),y
	sta $04a0+[$28*$a]

	ldy screen_b
	.for (var x=$26; x>$1f; x=x-1)
	{
		lda ($56),y
		sta $04a0+x+[$28*$b]
		iny
	}
	lda ($56),y
	sta $04a0+$1f+[$28*$b]
colour_inside_7:
	lda #$00
	sta $d022
	iny
colour_inside_8:
	lda #$00
	sta $d021
	sta $d026
colour_inside_9:
	lda #$00
	sta $d020
	sta $d023

	.for (var x=$1e; x>$10; x=x-1)
	{
		lda ($56),y
		sta $04a0+x+[$28*$b]
		iny
	}
	
	lda ($56),y
	stx $d016
	sta $04a0+$10+[$28*$b]
	iny
	
scroll_b:
	ldx #$1b	

	.for (var x=$0f; x>0; x=x-1)
	{
		lda ($56),y
		sta $04a0+x+[$28*$b]
		iny
	}
	lda ($56),y
	sta $04a0+[$28*$b]

screen_c:
	ldy #$28
	.for (var x=$26; x>$12; x=x-1)
	{
		lda ($58),y
		sta $04a0+x+[$28*$c]
		iny
	}
	
	stx $d016

scroll_c:
	ldx #$1c	

	.for (var x=$12; x>0; x=x-1)
	{
		lda ($58),y
		sta $04a0+x+[$28*$c]
		iny
	}
	lda ($58),y
	sta $04a0+[$28*$c]

screen_d:
	ldy #$28
	.for (var x=$26; x>$15; x=x-1)
	{
		lda ($5a),y
		sta $04a0+x+[$28*$d]
		iny
	}
	lda ($5a),y
	stx $d016
scroll_d:
	ldx #$1d
	
	sta $04a0+$15+[$28*$d]
	iny
	.for (var x=$14; x>$0; x=x-1)
	{
		lda ($5a),y
		sta $04a0+x+[$28*$d]
		iny
	}

screen_e:
	ldy #$28
	.for (var x=$26; x>$17; x=x-1)
	{
		lda ($5c),y
		sta $04a0+x+[$28*$e]
		iny
	}
	lda ($5c),y
	stx $d016
scroll_e:
	ldx #$1e
	sta $04a0+$17+[$28*$e]
	iny
	.for (var x=$16; x>$0; x=x-1)
	{
		lda ($5c),y
		sta $04a0+x+[$28*$e]
		iny
	}	

screen_f:
	ldy #$28
	.for (var x=$26; x>$19; x=x-1)
	{
		lda ($5e),y
		sta $04a0+x+[$28*$f]
		iny
	}
	lda ($5e),y
	stx $d016
	
scroll_f:
	ldx #$1f
	sta $04a0+$19+[$28*$f]
	iny
	.for (var x=$18; x>$0; x=x-1)
	{
		lda ($5e),y
		sta $04a0+x+[$28*$f]
		iny
	}		
	lda ($5e),y
	sta $04a0+[$28*$f]
	
	lda $37c2
	sta $d402
	lda $37c3
	sta $d403 
	lda $37c6 
	sta $d406 
	lda $37c5 
	sta $d405 
	lda $37c0 
	sta $d400 
	lda $37c1 
	sta $d401 
	lda $37c4 
	sta $d404 
	lda $37e2 
	sta $d422 
	lda $37e3 
	sta $d423 
	lda $37e6 
	sta $d426 
	lda $37e5 
	sta $d425 
	lda $37e0 
	sta $d420 
	lda $37e1 
	sta $d421 
	lda $37e4 
	sta $d424 
	lda $37d5
	sta $d415
	stx $d016
	lda $37f5
	sta $d435
	lda #$0e
	sta $d018
	lda #$19
	sta $d011
	lda #$00
	sta $d017
	ldx #$01
	.for (var x=1; x<3; x=x+1)
	{
		lda $37c2+[x*7]
		sta $d402+[x*7]
		lda $37c3+[x*7]
		sta $d403+[x*7]
		lda $37c6+[x*7]
		sta $d406+[x*7]
		lda $37c5+[x*7]
		sta $d405+[x*7]
		lda $37c0+[x*7]
		sta $d400+[x*7]
		lda $37c1+[x*7]
		sta $d401+[x*7]
		lda $37c4+[x*7]
		sta $d404+[x*7]
		lda $37e2+[x*7]
		sta $d422+[x*7]
		lda $37e3+[x*7]
		sta $d423+[x*7]
		lda $37e6+[x*7]
		sta $d426+[x*7]
		lda $37e5+[x*7]
		sta $d425+[x*7]
		lda $37e0+[x*7]
		sta $d420+[x*7]
		lda $37e1+[x*7]
		sta $d421+[x*7]
		lda $37e4+[x*7]
		sta $d424+[x*7]
	}
	lda $37d6
	sta $d416
	lda $37f6
	sta $d436
	lda $37d7
	sta $d417	
	lda $37f7
	sta $d437
	lda $37d8
	sta $d418
	lda $37f8
	sta $d438

colour_outside_0:	
	lda #$00
	sta $d022
	sta $d025
colour_outside_1:	
	lda #$00
	sta $d023
	sta $d023
	lda #%00000011
	sta $d01c
	stx $d020
	stx $d021
	ldx #$09
!:	dex
	bne !-
	ldx $06
colour_outside_2:
	ldy #$00
	stx $d020
	lda #$1f
	sty $d021
	sta $d011
	sty $d026

	lda #222
	sta $d001
	sta $d003
	lda #$03
	sta $d017

bottom_scroll_d016:
	lda #$07
	ora #$18
	sta $d016
	
	lda #%11111110
	sta $d010
	ldy #$ff
	sty $d005
	iny
	sty $d00b
	ldy #$08
	sty $d007
	sty $d009
	iny
	sty $d00d
	sty $d00f
	lda #$14
	sta $d004
	lda #$24
	sta $d006
	lda #$3c
	sta $d008
	lda #$15
	sta $d00a
	lda #$25
	sta $d00c
	lda #$3d
	sta $d00e
sprite_colour:
	ldy #$0d
	sty $d029
sprite_colour2:
	ldy #$01
	sty $d02a
	sty $d02b
	ldy #$00
	sty $d02c
	sty $d02d
	sty $d02e





	lda $3f
	beq go_down
	bpl scroll_up
	jmp scroll_down
go_down:
	lda #$00
	beq go_up
	lda select_tune+1
	cmp #[[music_load_end-music_load_start]/2]-1
	bcs go_up
	lda #$04
	sta $3f
	bne scroll_up
go_up:
	lda #$00
	bne !+
	jmp scroll_down_
!:	lda select_tune+1
	bne !+
	jmp scroll_down_
!:	lda #$fc
	sta $3f
	jmp scroll_down
scroll_up:
	.for (var i=0;i<$f;i=i+1)
	{
		lda $42+[i*2]
		sta $40+[i*2]
		lda $43+[i*2]
		sta $41+[i*2]	
	}
	lda $5f
	eor #$78
	beq !+
	lda $5e
	clc
	adc #$50
	sta $5e
	eor #$f0
	bne !+
	sta $5e
	inc $5f
!:	dec $3f
	bne scroll_up_
	inc select_tune+1
scroll_up_:
	jmp scroll_down_
scroll_down:
	.for (var i=$e;i>=0;i=i-1)
	{
		lda $40+[i*2]
		sta $42+[i*2]
		lda $41+[i*2]
		sta $43+[i*2]
	}
	
	//; at the top boundary?
	lda $41
	eor #$65
	beq !+
	lda $40
	sec
	sbc #$50
	sta $40
	eor #$b0
	bne !+
	lda #$a0
	sta $40
	dec $41
!:	inc $3f
	bne scroll_down_
	dec select_tune+1
scroll_down_:













sine_x0a:
	lda sine_x
sine_x0b:
	adc sine_x
	tax
	and #$07
	ora #$18
	sta scroll_0+1
	sta scroll_1+1
	txa
	lsr
	lsr
	lsr
	sta screen_0+1
	sta screen_1+1
	inc sine_x0a+1
sine_x0c:
	lda #$00
sine_x0d:	
	adc #$c0
	sta sine_x0c+1
	lda sine_x0b+1
sine_x0e:	
	adc #1
	sta sine_x0b+1

	clc
sine_x1a:
	lda sine_x
sine_x1b:
	adc sine_x
	tax
	and #$07
	ora #$18
	sta scroll_2+1
	sta scroll_3+1
	sta scroll_4+1
	sta scroll_5+1
	txa
	lsr
	lsr
	lsr
	sta screen_2+1
	sta screen_3+1
	sta screen_4+1
	sta screen_5+1
	inc sine_x1a+1
sine_x1c:
	lda #$00
sine_x1d:
	adc #$c4
	sta sine_x1c+1
	lda sine_x1b+1
sine_x1e:
	adc #1
	sta sine_x1b+1

	clc
sine_x2a:
	lda sine_x
sine_x2b:
	adc sine_x
	tax
	and #$07
	ora #$18
	sta scroll_6+1
	sta scroll_7+1
	sta scroll_8+1
	sta scroll_9+1
	txa
	lsr
	lsr
	lsr
	sta screen_6+1
	sta screen_7+1
	sta screen_8+1
	sta screen_9+1
	inc sine_x2a+1
sine_x2c:
	lda #$00
sine_x2d:
	adc #$c8
	sta sine_x2c+1
	lda sine_x2b+1
sine_x2e:
	adc #1
	sta sine_x2b+1

	clc
sine_x3a:
	lda sine_x
sine_x3b:
	adc sine_x
	tax
	and #$07
	ora #$18
	sta scroll_a+1
	sta scroll_b+1
	sta scroll_c+1
	sta scroll_d+1
	txa
	lsr
	lsr
	lsr
	sta screen_a+1
	sta $05
	sta screen_c+1
	sta screen_d+1
	inc sine_x3a+1
sine_x3c:
	lda #$00
sine_x3d:
	adc #$cc
	sta sine_x3c+1
	lda sine_x3b+1
sine_x3e:
	adc #1
	sta sine_x3b+1

	clc
sine_x4a:
	lda sine_x
sine_x4b:
	adc sine_x
	tax
	and #$07
	ora #$18
	sta scroll_e+1
	sta scroll_f+1
	txa
	lsr
	lsr
	lsr
	sta screen_e+1
	sta screen_f+1
	inc sine_x4a+1
sine_x4c:
	lda #$00
sine_x4d:
	adc #$d0
	sta sine_x4c+1
	lda sine_x4b+1
sine_x4e:
	adc #1
	sta sine_x4b+1

	clc
	lda screen_d+1
	adc #$26
	tay
	lda ($5a),y
	sta $04a0+[$28*$d]
	lda screen_e+1
	adc #$26
	tay
	lda ($5c),y
	sta $04a0+[$28*$e]	
	
screen_0:
	ldy #$00
	.for (var x=$26; x>$0; x=x-1)
	{
		lda ($40),y
		sta $04a0+x+[$28*0]
		iny
	}
	lda ($40),y
	sta $04a0+[$28*0]
screen_6:
	ldy #$00
	.for (var x=$26; x>$0; x=x-1)
	{
		lda ($4c),y
		sta $04a0+x+[$28*6]
		iny
	}
	lda ($4c),y
	sta $04a0+[$28*6]
	
sinx1:
	ldx #$00
	lda sine_x_table,x
	adc #$04
	sta sprite_sinex+1
	inx
	txa
	and #$1f
	sta sinx1+1

sinx2:
	ldx #$06
	lda sine_x_table,x
	sta logo_sinex+1
	inx
	txa
	and #$1f
	sta sinx2+1




	

vol_down:
	ldx #$2b
	bne vol_down_
go_fire:
	lda #$00
	beq !+
select_tune:
	lda #$02
	cmp load_tune+1
	beq !+
	sta load_tune+1
vol_down_:
	inx
!:	cpx #$2c
	bne !+
	dex
!:	stx vol_down+1

	inc play_it+1
	
	lda #$01
	sta $d019
	lda #<irq_4
	sta $fffe
	lda #>irq_4
	sta $ffff
	lda #$f9
	sta $d012	
	ldy $02
	ldx $03
	lda #$00
	sta $01
	lda $04
	rti